osl::checkmate::ProofTreeDepthDfpn::Table Struct Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Types | Public Member Functions | Public Attributes | List of all members
osl::checkmate::ProofTreeDepthDfpn::Table Struct Reference

深さを記憶するテーブル. More...

Collaboration diagram for osl::checkmate::ProofTreeDepthDfpn::Table:
[legend]

## Public Types
typedef osl::hash_map< HashKey, std::pair< int, Move > > | map_t
typedef std::pair< const HashKey, std::pair< int, Move > > | entry_t
typedef slist< const entry_t * > | list_t
typedef hash_map< BoardKey, list_t > | index_t

## Public Member Functions
| Table (const DfpnTable &t)
void | store (const HashKey &key, int depth, Move best_move=Move())
bool | find (const HashKey &key, int &depth, Move &best_move) const
bool | expectMoreDepth (Player attack, const HashKey &key, int depth) const
int | maxDepth () const

## Public Attributes
boost::scoped_array < NumEffectState > | state
map_t | depth_table
index_t | depth_index
const DfpnTable & | table

## Detailed Description

深さを記憶するテーブル.

-1 は探索中

Definition at line 16 of file proofTreeDepthDfpn.cc.

## Member Typedef Documentation

typedef std::pair<const HashKey, std::pair<int, Move> > osl::checkmate::ProofTreeDepthDfpn::Table::entry_t

Definition at line 20 of file proofTreeDepthDfpn.cc.

typedef hash_map<BoardKey, list_t> osl::checkmate::ProofTreeDepthDfpn::Table::index_t

Definition at line 22 of file proofTreeDepthDfpn.cc.

typedef slist<const entry_t*> osl::checkmate::ProofTreeDepthDfpn::Table::list_t

Definition at line 21 of file proofTreeDepthDfpn.cc.

typedef osl::hash_map<HashKey, std::pair<int, Move> > osl::checkmate::ProofTreeDepthDfpn::Table::map_t

Definition at line 19 of file proofTreeDepthDfpn.cc.

## Constructor & Destructor Documentation

osl::checkmate::ProofTreeDepthDfpn::Table::Table | ( | const DfpnTable & | t) |  |
| inline

Definition at line 26 of file proofTreeDepthDfpn.cc.

## Member Function Documentation

bool osl::checkmate::ProofTreeDepthDfpn::Table::expectMoreDepth | ( | Player | attack,
|  | const HashKey & | key,
|  | int | depth
| ) |  | const
| inline

Definition at line 44 of file proofTreeDepthDfpn.cc.

References osl::BLACK, and depth_index.

bool osl::checkmate::ProofTreeDepthDfpn::Table::find | ( | const HashKey & | key,
|  | int & | depth,
|  | Move & | best_move
| ) |  | const
| inline

Definition at line 35 of file proofTreeDepthDfpn.cc.

References depth_table.

int osl::checkmate::ProofTreeDepthDfpn::Table::maxDepth | ( | ) |  | const
| inline

Definition at line 72 of file proofTreeDepthDfpn.cc.

References osl::checkmate::DfpnTable::maxDepth(), and table.

void osl::checkmate::ProofTreeDepthDfpn::Table::store | ( | const HashKey & | key,
|  | int | depth,
|  | Move | best_move = `Move()`
| ) |  |
| inline

Definition at line 29 of file proofTreeDepthDfpn.cc.

References depth_index, and depth_table.

## Member Data Documentation

index_t osl::checkmate::ProofTreeDepthDfpn::Table::depth_index

Definition at line 24 of file proofTreeDepthDfpn.cc.

Referenced by expectMoreDepth(), and store().

map_t osl::checkmate::ProofTreeDepthDfpn::Table::depth_table

Definition at line 23 of file proofTreeDepthDfpn.cc.

Referenced by find(), and store().

boost::scoped_array<NumEffectState> osl::checkmate::ProofTreeDepthDfpn::Table::state

Definition at line 18 of file proofTreeDepthDfpn.cc.

const DfpnTable& osl::checkmate::ProofTreeDepthDfpn::Table::table

Definition at line 25 of file proofTreeDepthDfpn.cc.

Referenced by maxDepth().

The documentation for this struct was generated from the following file:

- proofTreeDepthDfpn.cc